<%@ Page Language="VB" MasterPageFile="~/MasterPage.master" AutoEventWireup="false" CodeFile="Default.aspx.vb" Inherits="PhotoAdmin_Default" title="Untitled Page" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
    <h3>
        Manage Your Photo Album</h3>
        <asp:Label ID="UserIdValue" runat="server" Visible="False"></asp:Label>&nbsp;
    <asp:HyperLink ID="lnkManageCategories" runat="server" NavigateUrl="~/PhotoAdmin/ManageCategories.aspx">Manage Your Categories</asp:HyperLink><p>
        <strong>Add a New Photo to Your Album</strong>&nbsp;</p>
    <p>
        <asp:SqlDataSource ID="categoriesDataSource" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>" SelectCommand="SELECT [CategoryID], [UserId], [Name] FROM [Categories] WHERE ([UserId] = @UserId) ORDER BY [Name]">
            <SelectParameters>
                <asp:ControlParameter ControlID="UserIdValue" Name="UserId" PropertyName="Text" />
            </SelectParameters>
        </asp:SqlDataSource>

        <asp:SqlDataSource ID="picturesDataSource" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>"
            DeleteCommand="DELETE FROM [Pictures] WHERE [PictureID] = @PictureID" InsertCommand="INSERT INTO [Pictures] ([UserId], [CategoryID], [Title], [Description], [UploadedOn]) VALUES (@UserId, @CategoryID, @Title, @Description, @UploadedOn)"
            SelectCommand="SELECT * FROM [Pictures] WHERE ([UserId] = @UserId) ORDER BY [UploadedOn] DESC"
            UpdateCommand="UPDATE [Pictures] SET [UserId] = @UserId, [CategoryID] = @CategoryID, [Title] = @Title, [Description] = @Description, [UploadedOn] = @UploadedOn WHERE [PictureID] = @PictureID">
            <DeleteParameters>
                <asp:Parameter Name="PictureID" Type="Int32" />
            </DeleteParameters>
            <UpdateParameters>
                <asp:Parameter Name="UserId" />
                <asp:Parameter Name="CategoryID" Type="Int32" />
                <asp:Parameter Name="Title" Type="String" />
                <asp:Parameter Name="Description" Type="String" />
                <asp:Parameter Name="UploadedOn" Type="DateTime" />
                <asp:Parameter Name="PictureID" Type="Int32" />
            </UpdateParameters>
            <SelectParameters>
                <asp:ControlParameter ControlID="UserIdValue" Name="UserId" PropertyName="Text" />
            </SelectParameters>
            <InsertParameters>
                <asp:Parameter Name="UserId" />
                <asp:Parameter Name="CategoryID" Type="Int32" />
                <asp:Parameter Name="Title" Type="String" />
                <asp:Parameter Name="Description" Type="String" />
                <asp:Parameter Name="UploadedOn" Type="DateTime" />
            </InsertParameters>
        </asp:SqlDataSource>
        <asp:SqlDataSource ID="maxPictureIDDataSource" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>"
            SelectCommand="SELECT MAX(PictureID) FROM Pictures WHERE UserId = @UserId">
            <SelectParameters>
                <asp:ControlParameter ControlID="UserIdValue" Name="UserId" PropertyName="Text" />
            </SelectParameters>
        </asp:SqlDataSource>
        <asp:Label ID="cannotUploadImageMessage" runat="server" Font-Italic="True" ForeColor="Red"
            Text="The photo could not be added to your album either because you did not specify a file to upload or the file specified was not a JPEG image with the file extension .JPG."
            Visible="False"></asp:Label>
        <asp:DetailsView ID="dvPictureInsert" runat="server" AutoGenerateRows="False" CellPadding="4"
            DataKeyNames="PictureID" DataSourceID="picturesDataSource" DefaultMode="Insert"
            ForeColor="#333333" GridLines="None" Height="50px" Width="125px">
            <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <CommandRowStyle BackColor="#D1DDF1" Font-Bold="True" />
            <EditRowStyle BackColor="#2461BF" />
            <RowStyle BackColor="#EFF3FB" />
            <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
            <Fields>
                <asp:BoundField DataField="PictureID" HeaderText="PictureID" InsertVisible="False"
                    ReadOnly="True" SortExpression="PictureID" />
                <asp:TemplateField HeaderText="Picture">
                    <InsertItemTemplate>
                        &nbsp;<asp:FileUpload ID="imageUpload" runat="server" />
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator5" runat="server" ControlToValidate="imageUpload"
                            Display="Dynamic" ErrorMessage="You must select an image file to upload." Font-Italic="True"
                            ForeColor="White" ValidationGroup="PictureAdd"></asp:RequiredFieldValidator>
                    </InsertItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Category" SortExpression="CategoryID">
                    <EditItemTemplate>
                        <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("CategoryID") %>'></asp:TextBox>
                    </EditItemTemplate>
                    <InsertItemTemplate>
                        <asp:DropDownList ID="pictureCategory" runat="server" DataSourceID="categoriesDataSource"
                            DataTextField="Name" DataValueField="CategoryID" SelectedValue='<%# Bind("CategoryID") %>' AppendDataBoundItems="True">                            
                            <asp:ListItem Selected="True" Value="">-- None --</asp:ListItem>
                        </asp:DropDownList>
                    </InsertItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label1" runat="server" Text='<%# Bind("CategoryID") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Title" SortExpression="Title">
                    <EditItemTemplate>
                        <asp:TextBox ID="TextBox2" runat="server" Text='<%# Bind("Title") %>'></asp:TextBox>
                    </EditItemTemplate>
                    <InsertItemTemplate>
                        <asp:TextBox ID="TextBox2" runat="server" Text='<%# Bind("Title") %>'></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator3" runat="server" ControlToValidate="TextBox2"
                            Display="Dynamic" ErrorMessage="You must enter a title." Font-Italic="True" ForeColor="White"
                            ValidationGroup="PictureAdd"></asp:RequiredFieldValidator>
                    </InsertItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label2" runat="server" Text='<%# Bind("Title") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Description" SortExpression="Description">
                    <EditItemTemplate>
                        <asp:TextBox ID="TextBox3" runat="server" Text='<%# Bind("Description") %>'></asp:TextBox>
                    </EditItemTemplate>
                    <InsertItemTemplate>
                        <asp:TextBox ID="TextBox3" runat="server" Columns="25" Rows="4" Text='<%# Bind("Description") %>'
                            TextMode="MultiLine"></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator4" runat="server" ControlToValidate="TextBox3"
                            Display="Dynamic" ErrorMessage="You must enter a description." Font-Italic="True"
                            ForeColor="White" ValidationGroup="PictureAdd"></asp:RequiredFieldValidator>
                    </InsertItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label3" runat="server" Text='<%# Bind("Description") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:CommandField CancelText="" ShowInsertButton="True" ValidationGroup="PictureAdd" />
            </Fields>
            <FieldHeaderStyle BackColor="#DEE8F5" Font-Bold="True" />
            <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <AlternatingRowStyle BackColor="White" />
        </asp:DetailsView>
        <asp:GridView ID="gvPictures" runat="server" AutoGenerateColumns="False" CellPadding="4"
            DataKeyNames="PictureID" DataSourceID="picturesDataSource" ForeColor="#333333"
            GridLines="None" AllowPaging="True" AllowSorting="True" EmptyDataText="There are currently no pictures in your album.">
            <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <Columns>
                <asp:CommandField ShowDeleteButton="True" ShowEditButton="True" ValidationGroup="PictureEdit" />
                <asp:TemplateField HeaderText="Category" SortExpression="CategoryID">
                    <EditItemTemplate>
                        <asp:DropDownList ID="pictureEditCategories" runat="server" DataSourceID="categoriesDataSource"
                            DataTextField="Name" DataValueField="CategoryID" SelectedValue='<%# Bind("CategoryID") %>' AppendDataBoundItems="True">
                            <asp:ListItem Selected="True" Value="">-- None --</asp:ListItem>
                        </asp:DropDownList>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:DropDownList ID="pictureReadOnlyCategories" runat="server" DataSourceID="categoriesDataSource"
                            DataTextField="Name" DataValueField="CategoryID" Enabled="False" SelectedValue='<%# Bind("CategoryID") %>' AppendDataBoundItems="True">
                            <asp:ListItem Selected="True" Value="">-- None --</asp:ListItem>
                        </asp:DropDownList>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Title" SortExpression="Title">
                    <EditItemTemplate>
                        <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("Title") %>'></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator6" runat="server" ControlToValidate="TextBox1"
                            Display="Dynamic" ErrorMessage="You must enter a title." Font-Italic="True" ForeColor="White"
                            ValidationGroup="PictureEdit"></asp:RequiredFieldValidator>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label1" runat="server" Text='<%# Bind("Title") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Description" SortExpression="Description">
                    <EditItemTemplate>
                        <asp:TextBox ID="TextBox2" runat="server" Columns="25" Rows="4" Text='<%# Bind("Description") %>'
                            TextMode="MultiLine"></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator7" runat="server" ControlToValidate="TextBox2"
                            Display="Dynamic" ErrorMessage="You must provide a description." Font-Italic="True"
                            ForeColor="White" ValidationGroup="PictureEdit"></asp:RequiredFieldValidator>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label2" runat="server" Text='<%# Bind("Description") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Date Added" SortExpression="UploadedOn">
                    <EditItemTemplate>
                        <asp:Label ID="Label4" runat="server" Text='<%# Bind("UploadedOn") %>'></asp:Label>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label3" runat="server" Text='<%# Bind("UploadedOn") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:ImageField DataImageUrlField="PictureID" DataImageUrlFormatString="~/UploadedImages/{0}.jpg"
                    HeaderText="Image" ReadOnly="True">
                    <ControlStyle Width="100px" />
                </asp:ImageField>
            </Columns>
            <RowStyle BackColor="#EFF3FB" />
            <EditRowStyle BackColor="#2461BF" />
            <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
            <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
            <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <AlternatingRowStyle BackColor="White" />
        </asp:GridView>
    </p>
</asp:Content>

