<%@ Page Language="VB" MasterPageFile="~/MasterPage.master" AutoEventWireup="false" CodeFile="PhotoAlbum.aspx.vb" Inherits="PhotoAlbum" title="Untitled Page" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
    <h3>
        Photo Album</h3>
    <p>
        <asp:SqlDataSource ID="categoriesDataSource" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>"
            SelectCommand="SELECT [CategoryID], [Name] FROM [Categories] WHERE ([UserId] = @UserId) ORDER BY [Name]">
            <SelectParameters>
                <asp:QueryStringParameter Name="UserId" QueryStringField="ID" />
            </SelectParameters>
        </asp:SqlDataSource>
        <strong>Filter Pictures by Category: </strong>&nbsp;<asp:DropDownList AppendDataBoundItems="True" AutoPostBack="True" ID="categories" runat="server" DataSourceID="categoriesDataSource"
            DataTextField="Name" DataValueField="CategoryID">
            <asp:ListItem Value="">-- All --</asp:ListItem>
        </asp:DropDownList>
        <asp:SqlDataSource ID="picturesDataSource" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>" SelectCommand="SELECT PictureID, Title, UploadedOn FROM Pictures WHERE UserId = @UserId AND (CategoryID = @CategoryID OR @CategoryID IS NULL) ORDER BY UploadedOn DESC" CancelSelectOnNullParameter="False">
            <SelectParameters>
                <asp:QueryStringParameter Name="UserId" QueryStringField="ID" />
                <asp:ControlParameter ControlID="categories" Name="CategoryID" PropertyName="SelectedValue" />
            </SelectParameters>
        </asp:SqlDataSource>
        <asp:GridView ID="GridView1" runat="server" AllowPaging="True" AllowSorting="True"
            AutoGenerateColumns="False" CellPadding="4" DataKeyNames="PictureID" DataSourceID="picturesDataSource"
            ForeColor="#333333" GridLines="None" EmptyDataText='<br />There are no images that belong to the currently selected user category. Either select a different category or <a href="Default.aspx">select a different album</a>.'>
            <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <Columns>
                <asp:HyperLinkField DataNavigateUrlFields="PictureID" DataNavigateUrlFormatString="~/PhotoDetail.aspx?ID={0}"
                    Text="View" />
                <asp:BoundField DataField="Title" HeaderText="Title" SortExpression="Title" />
                <asp:BoundField DataField="UploadedOn" HeaderText="Date Added" SortExpression="UploadedOn" />
                <asp:ImageField DataImageUrlField="PictureID" DataImageUrlFormatString="~/UploadedImages/{0}.jpg"
                    HeaderText="Image">
                    <ControlStyle Width="150px" />
                </asp:ImageField>
            </Columns>
            <RowStyle BackColor="#EFF3FB" />
            <EditRowStyle BackColor="#2461BF" />
            <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
            <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
            <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <AlternatingRowStyle BackColor="White" />
            <EmptyDataRowStyle Font-Italic="True" />
        </asp:GridView>
    </p>
</asp:Content>

