<%@ Page Language="VB" MasterPageFile="~/MasterPage.master" AutoEventWireup="false" CodeFile="PhotoDetail.aspx.vb" Inherits="PhotoDetail" title="Untitled Page" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
    <asp:SqlDataSource ID="pictureDataSource" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>"
        SelectCommand="SELECT [Title], [Description], [PictureID] FROM [Pictures] WHERE ([PictureID] = @PictureID)">
        <SelectParameters>
            <asp:QueryStringParameter Name="PictureID" QueryStringField="ID" Type="Int32" />
        </SelectParameters>
    </asp:SqlDataSource>
    <asp:DetailsView ID="DetailsView1" runat="server" AutoGenerateRows="False" CellPadding="4"
        DataKeyNames="PictureID" DataSourceID="pictureDataSource" EmptyDataText='A valid picture ID was not passed to this page. Please <a href="Default.aspx">select a photo album</a> and try again.'
        ForeColor="#333333" GridLines="None" Height="50px" Width="125px">
        <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
        <CommandRowStyle BackColor="#D1DDF1" Font-Bold="True" />
        <EmptyDataRowStyle Font-Italic="True" ForeColor="Red" />
        <EditRowStyle BackColor="#2461BF" />
        <RowStyle BackColor="#EFF3FB" />
        <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
        <Fields>
            <asp:BoundField DataField="Title" HeaderText="Title" SortExpression="Title" />
            <asp:BoundField DataField="Description" HeaderText="Description" SortExpression="Description" />
            <asp:ImageField DataImageUrlField="PictureID" DataImageUrlFormatString="~/UploadedImages/{0}.jpg">
            </asp:ImageField>
        </Fields>
        <FieldHeaderStyle BackColor="#DEE8F5" Font-Bold="True" />
        <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
        <AlternatingRowStyle BackColor="White" />
    </asp:DetailsView>
    <asp:SqlDataSource ID="commentsDataSource" runat="server" ConnectionString="<%$ ConnectionStrings:ASPNETDBConnectionString %>" SelectCommand="SELECT [CommentID], [UserId], [PictureID], [Subject], [Body], [CommentMadeOn] FROM [Comments] WHERE ([PictureID] = @PictureID) ORDER BY [CommentMadeOn] DESC" DeleteCommand="DELETE FROM [Comments] WHERE [CommentID] = @CommentID" InsertCommand="INSERT INTO [Comments] ([UserId], [PictureID], [Subject], [Body], [CommentMadeOn]) VALUES (@UserId, @PictureID, @Subject, @Body, @CommentMadeOn)" UpdateCommand="UPDATE [Comments] SET [UserId] = @UserId, [PictureID] = @PictureID, [Subject] = @Subject, [Body] = @Body, [CommentMadeOn] = @CommentMadeOn WHERE [CommentID] = @CommentID">
        <SelectParameters>
            <asp:QueryStringParameter Name="PictureID" QueryStringField="ID" Type="Int32" />
        </SelectParameters>
        <DeleteParameters>
            <asp:Parameter Name="CommentID" Type="Int32" />
        </DeleteParameters>
        <UpdateParameters>
            <asp:Parameter Name="UserId" />
            <asp:Parameter Name="PictureID" Type="Int32" />
            <asp:Parameter Name="Subject" Type="String" />
            <asp:Parameter Name="Body" Type="String" />
            <asp:Parameter Name="CommentMadeOn" Type="DateTime" />
            <asp:Parameter Name="CommentID" Type="Int32" />
        </UpdateParameters>
        <InsertParameters>
            <asp:Parameter Name="UserId" />
            <asp:Parameter Name="PictureID" Type="Int32" />
            <asp:Parameter Name="Subject" Type="String" />
            <asp:Parameter Name="Body" Type="String" />
            <asp:Parameter Name="CommentMadeOn" Type="DateTime" />
        </InsertParameters>
    </asp:SqlDataSource>    
    <asp:LoginView ID="LoginView1" runat="server">
        <AnonymousTemplate>
            Only logged in users can leave comments.<br />
            <asp:LoginStatus ID="LoginStatus1" runat="server" />
        </AnonymousTemplate>
        <LoggedInTemplate>
                <asp:DetailsView ID="dvAddComment" runat="server" AutoGenerateRows="False" CellPadding="4"
                    DataKeyNames="CommentID" DataSourceID="commentsDataSource" DefaultMode="Insert"
                    ForeColor="#333333" GridLines="None" Height="50px" Width="125px" OnItemInserting="dvAddComment_ItemInserting">
                    <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <CommandRowStyle BackColor="#D1DDF1" Font-Bold="True" />
                    <EditRowStyle BackColor="#2461BF" />
                    <RowStyle BackColor="#EFF3FB" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                    <Fields>
                        <asp:TemplateField HeaderText="Subject" SortExpression="Subject">
                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("Subject") %>'></asp:TextBox>
                            </EditItemTemplate>
                            <InsertItemTemplate>
                                <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("Subject") %>'></asp:TextBox>
                                <asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" ControlToValidate="TextBox1"
                                    Display="Dynamic" ErrorMessage="You must enter a subject." Font-Italic="True"></asp:RequiredFieldValidator>
                            </InsertItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label1" runat="server" Text='<%# Bind("Subject") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Body" SortExpression="Body">
                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox2" runat="server" Text='<%# Bind("Body") %>'></asp:TextBox>
                            </EditItemTemplate>
                            <InsertItemTemplate>
                                <asp:TextBox ID="TextBox2" runat="server" Text='<%# Bind("Body") %>' Columns="35" Rows="5" TextMode="MultiLine"></asp:TextBox><br />
                                <asp:RequiredFieldValidator ID="RequiredFieldValidator2" runat="server" ControlToValidate="TextBox2"
                                    Display="Dynamic" ErrorMessage="You must provide a body for your comment." Font-Italic="True"></asp:RequiredFieldValidator>
                            </InsertItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label2" runat="server" Text='<%# Bind("Body") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:CommandField CancelText="" InsertText="Add Comment" ShowInsertButton="True" />
                    </Fields>
                    <FieldHeaderStyle BackColor="#DEE8F5" Font-Bold="True" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <AlternatingRowStyle BackColor="White" />
                </asp:DetailsView>
        </LoggedInTemplate>
    </asp:LoginView>
    <br />
    <asp:GridView ID="GridView1" runat="server" AllowPaging="True" AllowSorting="True"
        AutoGenerateColumns="False" CellPadding="4" DataKeyNames="CommentID" DataSourceID="commentsDataSource"
        ForeColor="#333333" GridLines="None">
        <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
        <Columns>
            <asp:BoundField DataField="Subject" HeaderText="Subject" SortExpression="Subject" />
            <asp:BoundField DataField="Body" HeaderText="Body" SortExpression="Body" />
            <asp:BoundField DataField="CommentMadeOn" HeaderText="Date" SortExpression="CommentMadeOn" />
        </Columns>
        <RowStyle BackColor="#EFF3FB" />
        <EditRowStyle BackColor="#2461BF" />
        <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
        <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
        <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
        <AlternatingRowStyle BackColor="White" />
    </asp:GridView>
</asp:Content>

